Namespace Calculate

    Public Class Answers

        Private _values As New List(Of Expressions.Values)

        Private Shared __instance As New Answers()

        Private Sub New()
        End Sub

        Public Shared ReadOnly Property Instance() As Answers
            Get
                Return __instance
            End Get
        End Property

        Public Shared Sub Push(ByVal values As Expressions.Values)
            Instance._Push(values)
        End Sub

        Public Shared ReadOnly Property Item(ByVal i As Expressions.Values) As Expressions.Values
            Get
                Return Instance(i)
            End Get
        End Property

        Public Sub _Push(ByVal values As Expressions.Values)
            _values.Add(values)
        End Sub

        Default Public ReadOnly Property _Item(ByVal i As Expressions.Values) As Expressions.Values
            Get
                Dim ret As New Expressions.Values

                For Each d_idx As Double In i
                    If Not IsInteger(d_idx) Then _
                        Throw New ArgumentException("Argument for function 'ans' must be integral.")
                    Dim idx As Integer = CInt(d_idx)

                    If idx < 1 OrElse idx > _values.Count Then _
                        Throw New ArgumentException("Argument for function 'ans' must point to a previous result.")

                    ret.AddRange(_values(_values.Count - CInt(d_idx)))
                Next

                Return ret
            End Get
        End Property

        Private Function IsInteger(ByVal d As Double) As Boolean
            Return Math.Ceiling(d) = d
        End Function

    End Class

End Namespace