Namespace Calculate

    Public Class BackgroundComputer

#Region " Public "

        Public Delegate Function Fun() As Expressions.Values
        Public Delegate Function Fun1(ByVal p As Expressions.Values()) As Expressions.Values

#Region " Constructors "

        Private Sub New()
            Reader.State = InputReader.ActionState.Computation
        End Sub

        Public Sub New(ByVal instance As Fun)
            Me.New()
            _instance = instance
            _t.Start()
        End Sub

        Public Sub New(ByVal instance As Fun1, ByVal ParamArray p As Expressions.Values())
            Me.New()
            _instance1 = instance
            _p = p
            _t.Start()
        End Sub

#End Region

#Region " Properties "

        Public ReadOnly Property IsRunning() As Boolean
            Get
                Return _t.IsAlive
            End Get
        End Property

        Public ReadOnly Property ReturnValue() As Expressions.Values
            Get
                Return _ret
            End Get
        End Property

        Public ReadOnly Property [Error]() As Exception
            Get
                Return _error
            End Get
        End Property

#End Region

#Region " Methods "

        Public Sub Abort()
            If _t.IsAlive Then
                _t.Abort()
                Reader.State = InputReader.ActionState.Input
            End If
        End Sub

#End Region

#End Region

        Private _instance As Fun
        Private _instance1 As Fun1
        Private _error As Exception
        Private _ret As Expressions.Values
        Private _p As Expressions.Values()
        Private _t As New Threading.Thread(AddressOf Begin)

        Private Sub Begin()
            Dim success As Boolean = False

            Try
                If _instance IsNot Nothing Then
                    _ret = _instance()
                ElseIf _instance1 IsNot Nothing Then
                    _ret = _instance1(_p)
                End If

                success = True
            Catch ex As Exception
                _error = ex
            Finally
                If Not success Then _ret = Nothing
            End Try
        End Sub

    End Class

End Namespace