Namespace Calculate.Expressions

    Public Class InfixExpression : Inherits Expression

#Region " Public "

#Region " Constructors "

        <DebuggerHidden()> _
        Public Sub New(ByVal expression As String, Optional ByVal start As Integer = 0)
            MyBase.New(expression, start)
        End Sub

#End Region

#Region " Methods "

        Public Overrides Function TryParse(ByRef ret As ParsedExpression) As Boolean
            Scanner = New Parser.InfixScanner(Expression, Start)

            Dim tokens As New Stack ' This is needed so we get the reverse order.
            Stack = New Stack
            Dim parser As New Parser.InfixParser(Expression, Scanner, tokens)

            If Not parser.TryParse() Then
                [Error] = parser.Error
                ret = Nothing
                Return False
            Else
                ' Reverse the order of the stack.
                Do Until tokens.Count = 0
                    Stack.Push(tokens.Pop())
                Loop

                ret = New ParsedExpression(Expression, Stack)
                Return True
            End If
        End Function

#End Region

#End Region

    End Class

End Namespace