Namespace Calculate.Expressions

    Public Class ParsedExpression

#Region " Public "

        Public ReadOnly Variables As New Dictionary(Of String, Values)()

#Region " Constructors "

        Public Sub New(ByVal expression As String, ByVal stack As Stack)
            Me.Stack = stack
            Me.Expression = expression

            For Each tok As StackToken In stack
                If TypeOf tok Is VariableToken AndAlso Not Variables.ContainsKey(tok.ToString()) Then
                    Variables.Add(tok.ToString(), Nothing)
                End If
            Next
        End Sub

#End Region

#Region " Methods "

        Public Function Execute() As Values
            Static null_params As New Dictionary(Of String, Values)()
            Return Execute(null_params)
        End Function

        Public Function Execute(ByVal params As Dictionary(Of String, Values)) As Values
            Dim new_stack As Stack = Stack.Clone()

            new_stack.Variables = Variables
            Calculate.Variables.JoinTo(new_stack.Variables)
            Return new_stack.Execute(params)
        End Function

        Public Overrides Function ToString() As String
            Return Expression
        End Function

#End Region

#End Region

#Region " Private "

        Private ReadOnly Stack As Stack
        Private ReadOnly Expression As String

#End Region

    End Class

End Namespace