Imports T = System.Double
Imports madrat.Utility.Functional
Imports madrat.Calculate.Expressions

Namespace Calculate

    Public Class [Function]

#Region " Public "

        Public ReadOnly Name As String
        Public ReadOnly ArgumentNumber As Integer
        Public ReadOnly Params As String()

        Public Delegate Function ExecuteFunction(ByVal sender As [Function], ByVal values As Values()) As Values
        Public Delegate Function ExecuteFunction1(ByVal sender As [Function], ByVal value As Values) As Values

#Region " Constructor "

        Public Sub New(ByVal name As String, ByVal argument_number As Integer)
            Me.Name = name
            Me.ArgumentNumber = argument_number
        End Sub

        Public Sub New(ByVal name As String, ByVal params As String(), ByVal [function] As ExecuteFunction)
            Me.New(name, params.Length)
            Me.fun = [function]
            Me.Params = params
        End Sub

        Public Sub New(ByVal name As String, ByVal [function] As ExecuteFunction1)
            Me.New(name, 1)
            Me.fun1 = [function]
        End Sub

#End Region

#Region " Methods "

        Public Overrides Function ToString() As String
            Return Name
        End Function

        Public Function Perform(ByVal ParamArray values As Values()) As Values
            Select Case Name
                Case "sin"
                    Return New Values(Map(Of T, T)(values(0), AddressOf Math.Sin))
                Case "cos"
                    Return New Values(Map(Of T, T)(values(0), AddressOf Math.Cos))
                Case "tan"
                    Return New Values(Map(Of T, T)(values(0), AddressOf Math.Tan))
                Case "exp"
                    Return New Values(Map(Of T, T)(values(0), AddressOf Math.Exp))
                Case "log"
                    Return New Values(Map(Of T, T)(values(0), AddressOf Math.Log10))
                Case "ln"
                    Return New Values(Map(Of T, T)(values(0), AddressOf Math.Log))
                Case "lg"
                    Return _
                        New Values(Map(Of T, T)(values(0), AddressOf Math.Log)) / _
                        New Values(Map(Of T, T)(values(1), AddressOf Math.Log))
                Case "sqrt"
                    Return New Values(Map(Of T, T)(values(0), AddressOf Math.Sqrt))
                Case "fact"
                    Return New Values(Map(Of T, T)(values(0), AddressOf Arithmetics.Factorial))
                Case "ans"
                    Return Answers.Item(values(0))
                Case Else
                    If fun IsNot Nothing Then
                        Return New Values(fun(Me, values))
                    ElseIf fun1 IsNot Nothing Then
                        Return New Values(fun1(Me, values(0)))
                    End If
            End Select

            Return New Values()
        End Function

#Region " Static "

        Public Shared Function KnownFunction(ByVal name As String) As [Function]
            Select Case name.ToLower()
                Case "sin", "cos", "tan", "exp", "log", "ln", "sqrt", "fact", "ans"
                    Return New [Function](name.ToLower(), 1)
                Case "lg"
                    Return New [Function](name.ToLower(), 2)
                Case Else
                    Return Nothing
            End Select
        End Function

#End Region

#End Region

#End Region

#Region " Private "

        Private ReadOnly fun As ExecuteFunction
        Private ReadOnly fun1 As ExecuteFunction1

#End Region

    End Class

End Namespace