Namespace Calculate

    Public Class Parameter

#Region " Public "

        Public ReadOnly Name As String
        Public ReadOnly ShortName As String
        Public ReadOnly Description As String

#Region " Constructors "

        Public Sub New(ByVal name As String, ByVal description As String)
            Me.Name = name
            Me.Description = description
        End Sub

        Public Sub New(ByVal name As String, ByVal short_name As String, ByVal description As String)
            Me.New(name, description)
            Me.ShortName = short_name
        End Sub

#End Region

#Region " Methods "

        Public Overrides Function ToString() As String
            Return ToStringBuilder().ToString()
        End Function

        Public Overridable Function ToStringBuilder() As Text.StringBuilder
            Dim ret As New IO.StringWriter()
            ret.WriteLine( _
                "    {0,-10} {1,-2} {2}", Name, ShortName, _
                Utility.Display.WrapLongText(Description, 79, 18).Trim() _
            )

            Return ret.GetStringBuilder()
        End Function

#End Region

#End Region

    End Class

End Namespace