Imports IntPair = System.Collections.Generic.KeyValuePair(Of Integer, Integer)

Namespace Calculate.Parser

    Public MustInherit Class Token

        Private _position As IntPair

        Protected Sub New()
        End Sub

        Protected Sub New(ByVal position As IntPair)
            Me.Position = position
        End Sub

        Public Property Position() As IntPair
            Get
                Return _position
            End Get
            Private Set(ByVal value As IntPair)
                _position = value
            End Set
        End Property

    End Class

    Public Class EndOfStreamToken : Inherits Token

    End Class

    Public Class ErrorToken : Inherits Token

        Public Sub New(ByVal position As Integer)
            MyBase.New(New IntPair(position, position))
        End Sub

    End Class

End Namespace