Namespace Calculate

    Public Class Variables

#Region " Public "

        Public Shared Property Item(ByVal name As String) As Expressions.Values
            Get
                Return Variables(name)
            End Get
            Set(ByVal value As Expressions.Values)
                Variables(name) = value
            End Set
        End Property

        Public Shared Function Contains(ByVal name As String) As Boolean
            Return Variables.ContainsKey(name)
        End Function

        Public Shared Sub JoinTo(ByVal dict As Dictionary(Of String, Expressions.Values))
            For Each var As KeyValuePair(Of String, Expressions.Values) In Variables
                If dict.ContainsKey(var.Key) AndAlso dict(var.Key) IsNot Nothing Then Continue For
                dict(var.Key) = var.Value
            Next
        End Sub

        Public Shared Sub Add(ByVal name As String, ByVal value As Expressions.Values)
            Variables.Add(name, value)
        End Sub

        Public Shared Sub Remove(ByVal name As String)
            If Not _variables.ContainsKey(name) Then Return
            Variables.Remove(name)
        End Sub

        Public Shared Function Iterator() As Dictionary(Of String, Expressions.Values).KeyCollection.Enumerator
            Return Variables.Keys.GetEnumerator()
        End Function

#End Region

#Region " Private "

        Private Shared _variables As New Dictionary(Of String, Expressions.Values)

        Private Shared ReadOnly Property Variables() As Dictionary(Of String, Expressions.Values)
            <DebuggerHidden()> _
            Get
                Return _variables
            End Get
        End Property

#End Region

    End Class

End Namespace